#include <stdlib.h>
#include <stdio.h>
#include <fcntl.h>
#include <hw/i2c.h>
#include <memory.h>
#include <errno.h>


const char *filename = "/dev/i2c0";
struct dataBuf
{
	i2c_sendrecv_t header;
	unsigned char data[20];
};
int main(int argc, char *argv[]) {
	printf("I2C driver demonstration program\n");
	int fd = open( filename, O_RDONLY );
	if( fd )
	{
		struct dataBuf dev_data;
		int ret;
		int i;
		memset( dev_data.data, 0, sizeof(dev_data.data));
		dev_data.header.slave.addr = 0x50; // address of factory config information
		dev_data.header.slave.fmt  = I2C_ADDRFMT_7BIT;
		dev_data.header.send_len = 1;  // one byte for the register offset
		dev_data.header.recv_len = 6; //  mac address
		dev_data.header.stop = 1;
		dev_data.data[0] = 8;	// use offset 8


		ret = devctl( fd, DCMD_I2C_SENDRECV, &dev_data, sizeof(dev_data), NULL );
		printf( "ret = %d, address: 0x%x, offset: 0x%x\nData:\t", ret, dev_data.header.slave.addr, 8 );
		for( i = 0; i < 6; i ++ )
		{
			printf( "%02x ", dev_data.data[i] );
		}
		printf( "\n" );

	}
	else
	{
		printf( "error opening file. %s\n", filename );
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}
